/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator.
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.bodyfile;

import com.microsoft.rest.ServiceCall;
import com.microsoft.rest.ServiceCallback;
import com.microsoft.rest.ServiceResponse;
import java.io.InputStream;
import rx.Observable;

/**
 * An instance of this class provides access to all the operations defined
 * in Files.
 */
public interface Files {
    /**
     * Get file.
     *
     * @return the InputStream object if successful.
     */
    InputStream getFile();

    /**
     * Get file.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<InputStream> getFileAsync(final ServiceCallback<InputStream> serviceCallback);

    /**
     * Get file.
     *
     * @return the observable to the InputStream object
     */
    Observable<InputStream> getFileAsync();

    /**
     * Get file.
     *
     * @return the observable to the InputStream object
     */
    Observable<ServiceResponse<InputStream>> getFileWithServiceResponseAsync();

    /**
     * Get a large file.
     *
     * @return the InputStream object if successful.
     */
    InputStream getFileLarge();

    /**
     * Get a large file.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<InputStream> getFileLargeAsync(final ServiceCallback<InputStream> serviceCallback);

    /**
     * Get a large file.
     *
     * @return the observable to the InputStream object
     */
    Observable<InputStream> getFileLargeAsync();

    /**
     * Get a large file.
     *
     * @return the observable to the InputStream object
     */
    Observable<ServiceResponse<InputStream>> getFileLargeWithServiceResponseAsync();

    /**
     * Get empty file.
     *
     * @return the InputStream object if successful.
     */
    InputStream getEmptyFile();

    /**
     * Get empty file.
     *
     * @param serviceCallback the async ServiceCallback to handle successful and failed responses.
     * @return the {@link ServiceCall} object
     */
    ServiceCall<InputStream> getEmptyFileAsync(final ServiceCallback<InputStream> serviceCallback);

    /**
     * Get empty file.
     *
     * @return the observable to the InputStream object
     */
    Observable<InputStream> getEmptyFileAsync();

    /**
     * Get empty file.
     *
     * @return the observable to the InputStream object
     */
    Observable<ServiceResponse<InputStream>> getEmptyFileWithServiceResponseAsync();

}
